library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;

package leddcd_pckg is

component leddcd
    port (
    	blank: in STD_LOGIC;
        d: in UNSIGNED (3 downto 0);
        s: out STD_LOGIC_VECTOR (6 downto 0)
    );
end component;

end leddcd_pckg;


library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;

entity leddcd is
    port (
    	blank: in STD_LOGIC;	-- active-high blanking input
    	d: in UNSIGNED (3 downto 0);
        s: out STD_LOGIC_VECTOR (6 downto 0)
    );
end leddcd;

architecture leddcd_arch of leddcd is
signal s_tmp: STD_LOGIC_VECTOR(6 downto 0);
begin
    with d select
    s_tmp <= "1110111" when "0000", -- 0
             "0010010" when "0001", -- 1
             "1011101" when "0010", -- 2
             "1011011" when "0011", -- 3
             "0111010" when "0100", -- 4
             "1101011" when "0101", -- 5
             "1101111" when "0110", -- 6
             "1010010" when "0111", -- 7
             "1111111" when "1000", -- 8
             "1111011" when "1001", -- 9
             "1111110" when "1010", -- A
             "0101111" when "1011", -- b
             "1100101" when "1100", -- C
             "0011111" when "1101", -- d
             "1101101" when "1110", -- E
             "1101100" when others; -- F
             
	-- zero the outputs if the blanking signal is high,
	-- otherwise output the LED digit bit pattern
    s <= "0000000" when blank='1' else s_tmp;
end leddcd_arch;
